/*

 Gestione Stampa
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/
#include "sudoky.h"

int SudokyStampa( )
{
	//
	// Stampa
	//
// PostScript
#define PS_WIDTH 20       /* Size of each box (points)     */
#define PS_MARGIN 5       /* Margin around board (points)  */
#define PS_THICK 3        /* Width of thick lines (points) */
#define PS_THIN 1         /* Width of thin lines (points)  */
#define PS_BASELINE 5     /* Offset of character base line */

#define PS_TOTWIDTH (9*PS_WIDTH+2*PS_MARGIN)  /* Total board width */

	/* Page size */
#define PS_A4_WIDTH 612 
#define PS_A4_HEIGHT 792 

#define PS_LEFT_OFFSET ((PS_A4_WIDTH - PS_TOTWIDTH)/2) 
#define PS_BASE_OFFSET ((PS_A4_HEIGHT - PS_TOTWIDTH)/2) 

#define _STR(x)      #x
#define STR(x)       _STR(x)

    	//int i;
	int y,x;
	char *candidati;
	char *filename="/tmp/Printed.ps";
	FILE *f, *fopen();
	int fork_return=0;

	f = fopen(filename, "w");

	if (!f)
	{
		sprintf (BUFF,"Errore apertura %s",filename);
		printf (BUFF);
		Alert (BUFF,"Ok",NULL);
		return (1);
	}

    	//time_t t;

    	//time( &t );


    	fprintf( f,"%%!PS\n");
	fprintf( f,"%%%%BoundingBox: %d %d %d %d\n",
		PS_LEFT_OFFSET, PS_BASE_OFFSET,
		PS_LEFT_OFFSET + PS_TOTWIDTH, PS_BASE_OFFSET + PS_TOTWIDTH
		);
	fprintf( f,"%%%%Creator: Sudoku by Max Cavallo\n");

	fprintf( f,"%%%%EndComments\n");

    	/* Write the board contents as a string */
    	fprintf( f, "(" );

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)	
		{
			candidati=GetCandidati(y,x);
			if (strlen(candidati)==1)
				fprintf (f,"%s",candidati);
			else
				fprintf (f," ");
		}
	}
	fprintf( f, ")\n" );

    	/* Co-ordinate transform */
    	fprintf( f, "%d %d translate\n", PS_LEFT_OFFSET, PS_BASE_OFFSET );

    	/* Draw board - thin lines first, then thick lines */
    	fprintf( f,
	"0 setgray\n"
	STR( PS_THIN ) " setlinewidth "
	"1 8 "                                 /* index, followed by loop count */
	"{dup "                                                   /* keep index */
	STR( PS_WIDTH ) " mul " STR( PS_MARGIN ) " add "    /* Compute position */
	"dup dup dup\n"                                             /* 4 copies */
	"  " STR( PS_MARGIN ) " moveto "                       /* vertical line */
	"%d lineto "
	STR( PS_MARGIN ) " exch moveto "                     /* horizontal line */
	"%d exch lineto "
	"1 add"                                                 /* update index */
	"} repeat pop stroke\n"
	STR( PS_THICK ) " setlinewidth "         /* Repeat code for thick lines */
	"1 2 "
	"{dup "
	"%d mul " STR( PS_MARGIN ) " add "
	"dup dup dup\n"
	"  " STR( PS_MARGIN ) " moveto "
	"%d lineto "
	STR( PS_MARGIN ) " exch moveto "
	"%d exch lineto "
	"1 add"
	"} repeat pop stroke\n"
	/* Draw outside border */
	"1 setlinejoin "
	STR( PS_MARGIN ) " " STR( PS_MARGIN ) " moveto "
	STR( PS_MARGIN ) " %d lineto "
	"%d %d lineto "
	"%d " STR( PS_MARGIN ) " lineto closepath stroke\n"
	, PS_TOTWIDTH - PS_MARGIN, PS_TOTWIDTH - PS_MARGIN
	, 3 * PS_WIDTH
	, PS_TOTWIDTH - PS_MARGIN, PS_TOTWIDTH - PS_MARGIN
	, PS_TOTWIDTH - PS_MARGIN, PS_TOTWIDTH - PS_MARGIN
	, PS_TOTWIDTH - PS_MARGIN, PS_TOTWIDTH - PS_MARGIN
	);
    	/* Now the code for drawing digits */
    	fprintf( f, 
	"/Helvetica-Bold findfont 12 scalefont setfont\n"
	"0 81 "                                /* index, followed by loop count */
	"{2 copy 1 getinterval "                              /* load character */
	"dup stringwidth pop\n"                        /* and compute the width */
	"  " STR( PS_WIDTH ) " exch sub 2 div "              /* and the x-delta */
  	"2 index "                                            /* reload index */
  	"9 mod " STR( PS_WIDTH ) " mul add "
  	STR( PS_MARGIN ) " add\n"                     /* compute x coordinate */
	"  8 3 index 9 idiv sub "
  	STR( PS_WIDTH ) " mul %d add\n"               /* compute y coordinate */
	"  moveto show "                                              /* render */
  	"1 add"                                               /* update index */
  	"} repeat pop pop\n"
	, PS_MARGIN + PS_BASELINE
	);

	fclose (f);

	fork_return = fork();
	if (fork_return==0)
	{
		// only child goes here
		sprintf (BUFF,"kprinter %s",filename);
		system (BUFF);
		exit (1);
	}
	
	return (0);
}
